//+------------------------------------------------------------------+
//|                                                          IBS.mq4 |
//|                                                             Rosh |
//|               http://www.investo.ru/forum/viewtopic.php?t=127513 |
//+------------------------------------------------------------------+
#property copyright "Rosh"
#property link      "http://www.investo.ru/forum/viewtopic.php?t=127513"
//----
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Blue
#property indicator_color2 Red
#define SIGNAL_BAR  1

//---- input parameters
extern int     RSIPeriod=16;
extern double  TCurvature=0.618;
extern int     MAPeriod=10;
extern int     BandsPeriod=20;
extern int     BandsDeviations=2;
extern int     BandsShift=0;
extern bool Alerts  =true;
extern bool UseSound=true;
extern string SoundFile="Alert.wav";
bool SoundBuy  = False;
bool SoundSell = False;
bool ArrowBuy  = true;
bool ArrowSell = true;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
  //---- indicator buffers mapping  
    SetIndexBuffer(0,ExtMapBuffer1);
    SetIndexBuffer(1,ExtMapBuffer2);  
//---- drawing settings
    SetIndexStyle(0,DRAW_ARROW);
    SetIndexArrow(0,233); //241 option for different arrow head
    SetIndexStyle(1,DRAW_ARROW);
    SetIndexArrow(1,234); //242 option for different arrow head    
//----
    SetIndexEmptyValue(0,0.0);
    SetIndexEmptyValue(1,0.0);
    SetIndexEmptyValue(2,0.0);
//---- name for DataWindow
    SetIndexLabel(0,"Cronex T RSI BB Buy");
    SetIndexLabel(1,"Cronex T RSI BB Sell");
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
    int nBars,nCountedBars;

    nCountedBars=IndicatorCounted(); //ncountedbars 655
//---- check for possible errors
    if(nCountedBars<0) return(-1);
//---- last counted bar will be recounted    
    if(nCountedBars<=3)
       nBars=Bars-nCountedBars-4;
    
    if(nCountedBars>2)
      {
       nCountedBars--;
       nBars=Bars-nCountedBars-1; //number of bars in current chart-655-1
      }

   for (int ii=Bars; ii>0; ii--)
   {

      ExtMapBuffer1[ii]=0;
      ExtMapBuffer2[ii]=0;

 double myXo  =iCustom(NULL, 0, "Cronex T RSI BB",RSIPeriod,TCurvature,MAPeriod,BandsPeriod,BandsDeviations,BandsShift,5,ii);
 double myIBS =iCustom(NULL, 0, "Cronex T RSI BB",RSIPeriod,TCurvature,MAPeriod,BandsPeriod,BandsDeviations,BandsShift,6,ii);
                 
         if( myXo != EMPTY_VALUE && myXo != 0 && ArrowBuy){ //did it cross from below 50 
            ArrowBuy = False;           
            ExtMapBuffer1[ii] = Low[ii] - 20 * MarketInfo(Symbol(),MODE_POINT);
         }
         if (!ArrowBuy && (myXo == EMPTY_VALUE || myXo == 0)) ArrowBuy = True;  
      
         if(myIBS != EMPTY_VALUE && myIBS != 0 && ArrowSell){ //did it cross from above 50
            ArrowSell = False; 
            ExtMapBuffer2[ii] = High[ii] + 20 * MarketInfo(Symbol(),MODE_POINT);
         }
          if (!ArrowSell && (myIBS == EMPTY_VALUE || myIBS == 0)) ArrowSell = True; 
        }
   //+------------------------------------------------------------------+  
   if(Alerts){   
      if (ExtMapBuffer1[SIGNAL_BAR] != EMPTY_VALUE && ExtMapBuffer1[SIGNAL_BAR] != 0 && SoundBuy)
         {
         SoundBuy = False;
            if (UseSound) PlaySound (SoundFile);
               Alert("Cronex T RSI BB (", Symbol(), ", ", Period(), ")  -  BUY!!!"); 
         } 
      if (!SoundBuy && (ExtMapBuffer1[SIGNAL_BAR] == EMPTY_VALUE || ExtMapBuffer1[SIGNAL_BAR] == 0)) SoundBuy = True;  
            
  
      if (ExtMapBuffer2[SIGNAL_BAR] != EMPTY_VALUE && ExtMapBuffer2[SIGNAL_BAR] != 0 && SoundSell)
         {
         SoundSell = False;
            if (UseSound) PlaySound (SoundFile);
             Alert("Cronex T RSI BB (", Symbol(), ", ", Period(), ")  -  SELL!!!"); 
         } 
      if (!SoundSell && (ExtMapBuffer2[SIGNAL_BAR] == EMPTY_VALUE || ExtMapBuffer2[SIGNAL_BAR] == 0)) SoundSell = True;  
}}
//+------------------------------------------------------------------+